SystemOrganization addCategory: #'Fuel-Tests'!
SystemOrganization addCategory: #'Fuel-Core'!
SystemOrganization addCategory: #'Fuel-Core-Cluster'!

!LargePositiveInteger methodsFor: '*fuel' stamp: 'TristanBourgois 9/24/2010 14:21'!
fuelSerializer 

	^ FLLargePositiveIntegerClusterSerializer instance.! !

TestCase subclass: #FLClusterSerializerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Tests'!

!FLClusterSerializerTest methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/23/2010 15:09'!
testUniqueIds

	" 
	Inspect the mapping:
	FLClusterSerializer allSubclasses collect: [ :aClass | aClass->([aClass new id] ifError: [nil]) ]
	"

	| ids |
	ids := FLClusterSerializer allSubclasses 
		collect: [ :aClass | [aClass new id] ifError: [nil] ] 
		thenSelect: [ :obj | obj isNil not].
	self 
		assert: ids size = ids asSet size 
		description: 'Same id detected on two FLClusterSerializer subclasses'! !

TestCase subclass: #FLSerializationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Tests'!

!FLSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/23/2010 15:39'!
assertSerializationEqualityOf: anObject

	self assertSerializationEqualityOfAll: {anObject}! !

!FLSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/23/2010 15:39'!
assertSerializationEqualityOfAll: rootsCollection
	| materializedRoots |

	materializedRoots := self materializedRootsOfAll: rootsCollection..
			
	self assert: rootsCollection size equals: materializedRoots size.
	self should: [ rootsCollection includesAllOf: materializedRoots ]! !

!FLSerializationTest methodsFor: 'tests' stamp: 'TristanBourgois 9/24/2010 14:29'!
assertSerializationIdentityOf: anObject
	| materializedRoots |

	materializedRoots := self materializedRootsOfAll: {anObject}..
	

	self assert: 1 equals: materializedRoots size.
	self should: [ anObject == materializedRoots anyOne ]! !

!FLSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/23/2010 15:25'!
materializedRootsOfAll: rootsCollection
	| aByteArray aSerializer |

	aSerializer := FLSerializer on: (RWBinaryOrTextStream on: '') binary.
	aByteArray := (aSerializer serializeAll: rootsCollection) stream contents.
	^ (FLMaterializer on: aByteArray readStream) 
			materialize;
			materializedRoots
! !

!FLSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/23/2010 15:38'!
testCharacter
	self assertSerializationIdentityOf: $a! !

!FLSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/24/2010 02:49'!
testCrowdedOrderedCollection

	| anOrderedCollection |
	anOrderedCollection := OrderedCollection new.
	1 to: (2 raisedTo: 16) do: [ :index | anOrderedCollection add: index].

	self assertSerializationEqualityOf: anOrderedCollection! !

!FLSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/24/2010 03:10'!
testCrowdedRoot

	| anOrderedCollection |
	anOrderedCollection := IdentitySet new.
	1 to: (2 raisedTo: 17) do: [ :index | anOrderedCollection add: index ].

	self assertSerializationEqualityOfAll: anOrderedCollection! !

!FLSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/23/2010 15:38'!
testDictionary
	self assertSerializationEqualityOf: (Dictionary with: 1->2 with: #toto->'toto' with: 3->4).! !

!FLSerializationTest methodsFor: 'tests' stamp: 'TristanBourgois 9/24/2010 13:59'!
testFalse
	self assertSerializationIdentityOf: false! !

!FLSerializationTest methodsFor: 'tests' stamp: 'TristanBourgois 9/24/2010 15:10'!
testLargeNegativeInteger

self assertSerializationEqualityOf: -35431431613431399999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999.! !

!FLSerializationTest methodsFor: 'tests' stamp: 'TristanBourgois 9/24/2010 14:29'!
testLargePositiveInteger

self assertSerializationEqualityOf: 35431431613431399999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999.! !

!FLSerializationTest methodsFor: 'tests' stamp: 'TristanBourgois 9/25/2010 19:47'!
testMaxSmallInteger
	self assertSerializationIdentityOf: SmallInteger maxVal .
	! !

!FLSerializationTest methodsFor: 'tests' stamp: 'TristanBourgois 9/25/2010 19:46'!
testMinSmallIntegerNegative

	self assertSerializationEqualityOf: SmallInteger minVal ! !

!FLSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/23/2010 15:38'!
testNil
	self assertSerializationIdentityOf: nil! !

!FLSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/23/2010 15:38'!
testOrderedCollection

	self assertSerializationEqualityOf: (OrderedCollection with: 10 with: 20)! !

!FLSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/23/2010 15:38'!
testPair
	self assertSerializationEqualityOf:
			(Pair new
				left: 20;
				right: 30;
				yourself)! !

!FLSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/23/2010 15:38'!
testPoint
	self assertSerializationEqualityOf: 10@20! !

!FLSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/23/2010 15:38'!
testRectangule
	
	self assertSerializationEqualityOf: (10@20 corner: 30@40)! !

!FLSerializationTest methodsFor: 'tests' stamp: 'TristanBourgois 9/25/2010 19:47'!
testSmallInteger
	self assertSerializationIdentityOf: SmallInteger one.! !

!FLSerializationTest methodsFor: 'tests' stamp: 'TristanBourgois 9/25/2010 19:46'!
testSmallInteger0

	self assertSerializationIdentityOf: 0.! !

!FLSerializationTest methodsFor: 'tests' stamp: 'TristanBourgois 9/25/2010 19:37'!
testSmallIntegerNegative

	self assertSerializationIdentityOf: -42.! !

!FLSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/23/2010 15:51'!
testString
	self assertSerializationEqualityOf: 'tototototototototototototototototototo'! !

!FLSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/23/2010 15:51'!
testSymbol
	self assertSerializationIdentityOf: #totototototototo! !

!FLSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/23/2010 15:38'!
testToto
	| t |
	t := Titi new.
	t with: 'toto' with: 'titi' with: 20.
	self assertSerializationEqualityOf: t! !

!FLSerializationTest methodsFor: 'tests' stamp: 'TristanBourgois 9/24/2010 13:53'!
testTrue
	self assertSerializationIdentityOf: true! !

!Character methodsFor: '*Fuel' stamp: 'MartinDias 9/23/2010 17:41'!
fuelSerializer

	^ FLCharacterClusterSerializer instance! !

!LargeNegativeInteger methodsFor: '*fuel' stamp: 'TristanBourgois 9/24/2010 15:09'!
fuelSerializer 

	^ FLLargeNegativeIntegerClusterSerializer instance.! !

!SmallInteger methodsFor: '*Fuel' stamp: 'TristanBourgois 9/25/2010 19:35'!
fuelSerializer
	^(self<0)ifTrue: [
		FLSmallIntegerNegativeClusterSerializer instance ]
	   		 ifFalse: [
		 FLSmallIntegerClusterSerializer instance ]
	! !

!UndefinedObject methodsFor: '*Fuel' stamp: 'TristanBourgois 9/24/2010 13:56'!
fuelSerializer 

	^ FLNilTrueFalseClusterSerializer instance! !

!Symbol methodsFor: '*Fuel' stamp: 'MartinDias 9/23/2010 17:41'!
fuelSerializer

	^ FLSymbolClusterSerializer instance! !

Object subclass: #FLBenchmarks
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Tests'!

!FLBenchmarks commentStamp: '<historical>' prior: 0!
Usage:

FLBenchmarks new runBenchWith: FLBenchmarks new rectangles 

FLBenchmarks new runBenchWith: FLBenchmarks new points
FLBenchmarks new runBenchWith: FLBenchmarks new plainPairs

FLBenchmarks new runBenchWith: FLBenchmarks new nestedPairs

FLBenchmarks new runBenchWith: FLBenchmarks new plainSmallOrderedCollections 
FLBenchmarks new runBenchWith: FLBenchmarks new orderedCollectionsWithSharedElement 

FLBenchmarks new runBenchWith: FLBenchmarks new titis

FLBenchmarks new runBenchWith: FLBenchmarks new strings
FLBenchmarks new runBenchWith: FLBenchmarks new symbols

FLBenchmarks new runBenchWith: FLBenchmarks new smallIntegers 
!

!FLBenchmarks methodsFor: 'serializing' stamp: 'MartinDias 9/24/2010 10:28'!
fuelSerializationBlock
	
	^ [ :aCollection | 
		| serializer |
		serializer := FLSerializer on: (RWBinaryOrTextStream on: '') binary.
		serializer serializeAll: aCollection.
		serializer stream contents ]! !

!FLBenchmarks methodsFor: 'test set' stamp: 'MartinDias 9/20/2010 23:40'!
nestedPairs 
	| aSet numberOfLeafs |
	numberOfLeafs := 2 raisedTo: 14.
	aSet := OrderedCollection new.
	1 to: numberOfLeafs do: [ :i | 
		aSet add: (
			Pair new 
				left: (2 * i); 
				right: (2 * i) + 1) ].
	
	[aSet size > 1] 
		whileTrue: [
			aSet := aSet pairsCollect: [ :leftPair :rightPair | 
				Pair new 
					left: leftPair;
					right: rightPair;
					yourself ] ].
	^aSet! !

!FLBenchmarks methodsFor: 'test set' stamp: 'MartinDias 9/22/2010 16:34'!
orderedCollectionsWithSharedElement
	| aSet aCollection |
	aSet := OrderedCollection new.
	1 to: (2 raisedTo: 9) do: [ :i | 
		aCollection := OrderedCollection new.
		100 timesRepeat: [ aCollection add: 17 ].
		aSet add: aCollection].
	^aSet.! !

!FLBenchmarks methodsFor: 'test set' stamp: 'MartinDias 9/20/2010 23:40'!
plainPairs
	| aSet |
	aSet := OrderedCollection new.
	1 to: (2 raisedTo: 15) by: 2 do: [ :i | 
		aSet add: (Pair new left: i; right: i+1)].
	^aSet.! !

!FLBenchmarks methodsFor: 'test set' stamp: 'MartinDias 9/22/2010 16:31'!
plainSmallOrderedCollections
	| aSet |
	aSet := OrderedCollection new.
	1 to: (2 raisedTo: 14) by: 2 do: [ :i | 
		aSet add: (OrderedCollection with: i with: i+1)].
	^aSet.! !

!FLBenchmarks methodsFor: 'test set' stamp: 'MartinDias 9/20/2010 23:40'!
points
	| aSet |
	aSet := OrderedCollection new.
	1 to: (2 raisedTo: 15) by: 2 do: [ :i | aSet add: i@(i+1)].
	^aSet.! !

!FLBenchmarks methodsFor: 'test set' stamp: 'MartinDias 9/20/2010 23:40'!
rectangles
	| rectangles |
	rectangles := OrderedCollection new.
	1 to: (2 raisedTo: 15) by: 4 do: [ :i | 
		rectangles add: (i@(i+1) corner: (i+2)@(i+3))].
	^rectangles.! !

!FLBenchmarks methodsFor: 'serializing' stamp: 'MartinDias 9/21/2010 11:27'!
referenceStreamSerializationBlock
	^ [ :aCollection | 
		| stream |
		stream := ReferenceStream on: (RWBinaryOrTextStream on: '') binary.
		stream nextPutAll: aCollection.
		stream contents]! !

!FLBenchmarks methodsFor: 'testing' stamp: 'MartinDias 9/22/2010 13:37'!
runBenchWith: aCollection
	Transcript clear.

	self runFuelBenchWith: aCollection.
	self runReferenceStreamBenchWith: aCollection.
	"self runMC2BenchWith: aCollection."

	Transcript flush.
! !

!FLBenchmarks methodsFor: 'testing' stamp: 'MartinDias 9/21/2010 12:53'!
runFuelBenchWith: aCollection

	| aByteArray materializer |

	Transcript show: '= Fuel Serialization ='; cr.
	self spy: [ aByteArray := self fuelSerializationBlock value: aCollection ] putResultsOn: Transcript.

	Transcript show: '= Fuel Materialization ='; cr.
	materializer := FLMaterializer on: aByteArray readStream.
	self spy: [ materializer materialize ] putResultsOn: Transcript.

! !

!FLBenchmarks methodsFor: 'serializing' stamp: 'MartinDias 9/22/2010 13:37'!
runMC2BenchWith: aCollection
"
	| serializer writeStream |

	writeStream := (RWBinaryOrTextStream on: '') binary.

	Transcript show: '= MC2 Serialization ='; cr.
	self spy: [
		serializer := MDSerializer on: writeStream. 
		serializer serialize: aCollection ]
			putResultsOn: Transcript.

	Transcript show: '= MC2 Materialization ='; cr.
	self spy: [ 
		MDMaterializer materialize: writeStream contents ] 
			putResultsOn: Transcript."! !

!FLBenchmarks methodsFor: 'testing' stamp: 'MartinDias 9/21/2010 12:53'!
runReferenceStreamBenchWith: aCollection

	| aByteArray stream referenceStreamMaterializedObjects |

	Transcript show: '= ReferenceStream Serialization ='; cr.
	self spy: [ aByteArray := self referenceStreamSerializationBlock value: aCollection ] putResultsOn: Transcript.

	Transcript show: '= ReferenceStream Materialization ='; cr.
	stream := ReferenceStream on: aByteArray readStream.
	referenceStreamMaterializedObjects := OrderedCollection new.
	self spy: [
		[ stream atEnd ] 
			whileFalse: [
				"referenceStreamMaterializedObjects add: "stream next ]
	] putResultsOn: Transcript.
! !

!FLBenchmarks methodsFor: 'test set' stamp: 'MartinDias 9/24/2010 10:04'!
smallIntegers
	| aSet |
	aSet := OrderedCollection new.
	1 to: (2 raisedTo: 30) by: (2 raisedTo: 13) do: [ :i | aSet add: i ].
	^aSet.! !

!FLBenchmarks methodsFor: 'testing' stamp: 'MartinDias 9/20/2010 19:29'!
spy: aBlockClosure putResultsOn: aWriteStream

	| messageTally |
	messageTally := MessageTally new 
		spyEvery: 1 on: aBlockClosure;
		yourself.
	
	aWriteStream nextPutAll: 'tally: ', messageTally tally printString, ' time: ', messageTally time printString; cr. ! !

!FLBenchmarks methodsFor: 'test set' stamp: 'MartinDias 9/24/2010 02:23'!
strings
	| anOrderedCollection |
	anOrderedCollection := OrderedCollection new.
	1 to: (2 raisedTo: 12) do: [ :index | anOrderedCollection add: (index" * 123456790") asString ].
	^ anOrderedCollection! !

!FLBenchmarks methodsFor: 'test set' stamp: 'MartinDias 9/23/2010 15:55'!
symbols
	| anOrderedCollection allSymbols |
	anOrderedCollection := OrderedCollection new.
	allSymbols := Symbol allSymbols.
	1 to: (2 raisedTo: 11) do: [ :index | 
		anOrderedCollection add: (allSymbols at: index) ].
	^ anOrderedCollection! !

!FLBenchmarks methodsFor: 'test set' stamp: 'MartinDias 9/23/2010 15:45'!
titis
	| anOrderedCollection |
	anOrderedCollection := OrderedCollection new.
	1 to: (2 raisedTo: 12) do: [ :i | anOrderedCollection add: (Titi with: 'toto' with:'titi'  with:i) ].
	^anOrderedCollection.! !

Object subclass: #FLClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLClusterSerializer methodsFor: 'as yet unclassified' stamp: 'sd 9/8/2010 14:35'!
id
	"Answer an unique byte identifier"
	self subclassResponsibility ! !

!FLClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/11/2010 21:31'!
materializeOn: aReadStream addTo: aCollection mainMaterializer: aMaterializer

	self subclassResponsibility ! !

!FLClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/12/2010 16:18'!
serializeAll: clusterInstances on: aWriteStream mainSerializer: aSerializer

	self subclassResponsibility ! !

FLClusterSerializer subclass: #FLObjectClusterSerializer
	instanceVariableNames: 'clusterClass'
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLObjectClusterSerializer class methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/24/2010 01:34'!
for: aClass

	^ self basicNew
		initialize: aClass;
		yourself.! !

!FLObjectClusterSerializer class methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/24/2010 01:34'!
instance
	^ Instance ifNil: [ Instance := self for: Object ]! !

!FLObjectClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/24/2010 02:04'!
= another
	^ (another isKindOf: FLObjectClusterSerializer) and: [ clusterClass = another clusterClass]! !

!FLObjectClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/24/2010 02:04'!
clusterClass
	^ clusterClass ! !

!FLObjectClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/24/2010 02:43'!
hash
	^ clusterClass hash! !

!FLObjectClusterSerializer methodsFor: 'as yet unclassified' stamp: 'sd 9/8/2010 16:39'!
id

	^0! !

!FLObjectClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/24/2010 01:31'!
initialize: aClass

	clusterClass := aClass! !

!FLObjectClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/23/2010 16:58'!
materializeOn: aReadStream addTo: aCollection mainMaterializer: aMaterializer
	"TODO make me nice, please!!"

	| instanceCount className class clusterInstances |
	className := aReadStream nextString.
	instanceCount := aReadStream nextWord.

	class := Smalltalk at: className asSymbol.
	clusterInstances := OrderedCollection new: instanceCount.

	class isVariable 
		ifTrue: [
			instanceCount timesRepeat: [ clusterInstances add: (class basicNew: aReadStream nextWord) ].
			aMaterializer referenceMaterializingActions 
				add: [ self materializeVariableReferencesOfAll: clusterInstances on: aReadStream mainMaterializer: aMaterializer ] ]
		ifFalse: [
			instanceCount timesRepeat: [ clusterInstances add: class basicNew ] ].

	class instSize > 0
		ifTrue: [
			aMaterializer referenceMaterializingActions 
				add: [ self materializeReferencesOfAll: clusterInstances on: aReadStream mainMaterializer: aMaterializer ]].

	aCollection addAll: clusterInstances.
! !

!FLObjectClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/23/2010 16:58'!
materializeReferencesOfAll: instances on: stream mainMaterializer: aMaterializer
	instances
		do: [ :instance |
			1 to: instance class instSize 
				do: [ :index | instance instVarAt: index put: aMaterializer nextReferencedObject ]]! !

!FLObjectClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/23/2010 16:58'!
materializeVariableReferencesOfAll: instances on: stream mainMaterializer: aMaterializer
	instances
		do: [ :instance |
			1 to: instance basicSize 
				do: [ :index | instance basicAt: index put: aMaterializer nextReferencedObject ]]! !

!FLObjectClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/24/2010 01:31'!
serializeAll: clusterInstances on: aWriteStream mainSerializer: aSerializer
	"TODO make me nice, please!!"

	aWriteStream nextStringPut: clusterClass name.
	aWriteStream nextWordPut: clusterInstances size.

	clusterClass isVariable 
		ifTrue: [
			clusterInstances do: [ :instance | aWriteStream nextWordPut: instance basicSize].
			
			aSerializer referenceSerializingActions 
				add: [self serializeVariableReferencesOfAll: clusterInstances on: aWriteStream mainSerializer: aSerializer ]].

	clusterClass instSize > 0 
		ifTrue: [ 
			aSerializer referenceSerializingActions 
				add: [self serializeReferencesOfAll: clusterInstances on: aWriteStream mainSerializer: aSerializer ]]
			
! !

!FLObjectClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/23/2010 17:01'!
serializeReferencesOfAll: instances on: stream mainSerializer: aSerializer 
	| class size |
	
	class := instances anyOne class.
	size := class instSize.
	instances 
		do: [ :anInstance |
			1 to: size do: [ :index |
				aSerializer addReferenceTo: (anInstance instVarAt: index) ]]
				
	! !

!FLObjectClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/23/2010 17:01'!
serializeVariableReferencesOfAll: instances on: aWriteStream mainSerializer: aSerializer

	instances 
		do: [ :anInstance |
			1 to: anInstance basicSize do: [ :index |
				aSerializer addReferenceTo: (anInstance basicAt: index) ]]! !

FLClusterSerializer subclass: #FLPrimitiveClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

FLPrimitiveClusterSerializer subclass: #FLByteIntegerClusterSerializer
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

FLPrimitiveClusterSerializer subclass: #FLCharacterClusterSerializer
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLCharacterClusterSerializer class methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/23/2010 17:45'!
instance
	^ Instance ifNil: [ Instance := self basicNew initialize ]! !

!FLCharacterClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/23/2010 15:08'!
id

	^1! !

!FLCharacterClusterSerializer methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/23/2010 12:34'!
materializeOn: aReadStream

	^Character value:(aReadStream next)! !

!FLCharacterClusterSerializer methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/23/2010 12:34'!
serialize: aCharacter on: aWriteStream

	aWriteStream nextPut:aCharacter value.! !

FLPrimitiveClusterSerializer subclass: #FLLargeNegativeIntegerClusterSerializer
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLLargeNegativeIntegerClusterSerializer class methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/24/2010 15:05'!
instance
	^ Instance ifNil: [ Instance := self basicNew initialize ]! !

!FLLargeNegativeIntegerClusterSerializer methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/24/2010 15:06'!
id
	^8! !

!FLLargeNegativeIntegerClusterSerializer methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/24/2010 15:12'!
materializeOn: aReadStream

	| size value |
	size:=aReadStream next.
	value := 0.
	size timesRepeat: [value := (value bitShift: 8) bitOr: aReadStream next].
	^ value negated ! !

!FLLargeNegativeIntegerClusterSerializer methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/24/2010 15:12'!
serialize: anInteger on: aWriteStream

	| size byte positive |
	positive:=anInteger abs.
	size:=(positive log: 256) floor + 1.
	aWriteStream nextPut:size.
	(size - 1 to: 0 by: -1) do:
		[:index |
		byte := (positive bitShift: index * -8) bitAnd: 255.
		aWriteStream nextPut: byte]! !

FLPrimitiveClusterSerializer subclass: #FLLargePositiveIntegerClusterSerializer
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLLargePositiveIntegerClusterSerializer class methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/24/2010 14:10'!
instance
	^ Instance ifNil: [ Instance := self basicNew initialize ]! !

!FLLargePositiveIntegerClusterSerializer methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/24/2010 14:09'!
id
	^9! !

!FLLargePositiveIntegerClusterSerializer methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/24/2010 14:19'!
materializeOn: aReadStream

	| size value |
	size:=aReadStream next.
	value := 0.
	size timesRepeat: [value := (value bitShift: 8) bitOr: aReadStream next].
	^ value! !

!FLLargePositiveIntegerClusterSerializer methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/24/2010 14:23'!
serialize: anInteger on: aWriteStream

	| size byte |
	size:=(anInteger log: 256) floor + 1.
	aWriteStream nextPut:size.
	(size - 1 to: 0 by: -1) do:
		[:index |
		byte := (anInteger bitShift: index * -8) bitAnd: 255.
		aWriteStream nextPut: byte]! !

FLPrimitiveClusterSerializer subclass: #FLNilTrueFalseClusterSerializer
	instanceVariableNames: 'primitiveDict'
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLNilTrueFalseClusterSerializer class methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/24/2010 13:36'!
instance
	^ Instance ifNil: [ Instance := self basicNew initialize ]! !

!FLNilTrueFalseClusterSerializer methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/24/2010 13:36'!
id

	^4! !

!FLNilTrueFalseClusterSerializer methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/24/2010 13:55'!
initialize 
	primitiveDict :=Dictionary new.
	primitiveDict add: nil-> 1;
	add: true ->2;
	add: false -> 3.  ! !

!FLNilTrueFalseClusterSerializer methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/24/2010 13:58'!
materializeOn: aReadStream
	
	^ primitiveDict keyAtValue: aReadStream next
	! !

!FLNilTrueFalseClusterSerializer methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/24/2010 13:45'!
serialize: aPrimitive on: aWriteStream

	aWriteStream nextPut: (primitiveDict at:aPrimitive)! !

FLPrimitiveClusterSerializer subclass: #FLOneByteIntegerClusterSerializer
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLOneByteIntegerClusterSerializer class methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/24/2010 00:55'!
instance
	^ Instance ifNil: [ Instance := self basicNew initialize ]! !

!FLOneByteIntegerClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/24/2010 00:35'!
id
	^6! !

!FLOneByteIntegerClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/24/2010 00:35'!
materializeOn: aReadStream

	^ aReadStream next! !

!FLOneByteIntegerClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/24/2010 00:33'!
serialize: anInteger on: aWriteStream

	aWriteStream nextPut: anInteger! !

!FLPrimitiveClusterSerializer methodsFor: 'as yet unclassified' stamp: 'sd 9/8/2010 17:50'!
materializeOn: aReadStream

	self subclassResponsibility ! !

!FLPrimitiveClusterSerializer methodsFor: 'materializing' stamp: 'MartinDias 9/11/2010 21:30'!
materializeOn: aReadStream addTo: aCollection mainMaterializer: aMaterializer 
	
	| instanceCount |
	instanceCount := aReadStream nextWord.

	instanceCount timesRepeat: 
		[aCollection add: 
			(self materializeOn: aReadStream)].! !

!FLPrimitiveClusterSerializer methodsFor: 'as yet unclassified' stamp: 'sd 9/8/2010 22:08'!
serialize: aByte on: aWriteStream
	self subclassResponsibility! !

!FLPrimitiveClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/11/2010 18:32'!
serializeAll: aCollection on: aWriteStream mainSerializer: anObject

	aWriteStream nextWordPut: aCollection size.
	aCollection do: [:instance| self serialize: instance on: aWriteStream ]! !

FLPrimitiveClusterSerializer subclass: #FLSmallIntegerClusterSerializer
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLSmallIntegerClusterSerializer class methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/24/2010 14:09'!
instance
	^ Instance ifNil: [ Instance := self basicNew initialize ]! !

!FLSmallIntegerClusterSerializer methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/24/2010 14:09'!
id
	^7! !

!FLSmallIntegerClusterSerializer methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/24/2010 15:04'!
materializeOn: aReadStream

	| hi lo |
	hi := aReadStream nextWord .
	lo := aReadStream nextWord.
	^ (hi bitShift: 8) + lo! !

!FLSmallIntegerClusterSerializer methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/24/2010 15:04'!
serialize: anInteger on: aWriteStream
	aWriteStream nextWordPut:  (anInteger bitShift: -8).
	aWriteStream nextWordPut: (anInteger bitAnd: 255).! !

FLPrimitiveClusterSerializer subclass: #FLSmallIntegerNegativeClusterSerializer
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLSmallIntegerNegativeClusterSerializer class methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/25/2010 19:33'!
instance
	^ Instance ifNil: [ Instance := self basicNew initialize ]! !

!FLSmallIntegerNegativeClusterSerializer methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/25/2010 19:33'!
id
	^10! !

!FLSmallIntegerNegativeClusterSerializer methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/25/2010 19:34'!
materializeOn: aReadStream

	| hi lo |
	hi := aReadStream nextWord .
	lo := aReadStream nextWord.
	^((hi bitShift: 8) + lo) negated! !

!FLSmallIntegerNegativeClusterSerializer methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/25/2010 19:36'!
serialize: anInteger on: aWriteStream
	|value|
	value:=anInteger abs.
	aWriteStream nextWordPut:  (value bitShift: -8).
	aWriteStream nextWordPut: (value bitAnd: 255).! !

FLPrimitiveClusterSerializer subclass: #FLStringClusterSerializer
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLStringClusterSerializer class methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/23/2010 17:46'!
instance
	^ Instance ifNil: [ Instance := self basicNew initialize ]! !

!FLStringClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/23/2010 15:08'!
id

	^5! !

!FLStringClusterSerializer methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/23/2010 08:47'!
materializeOn: aReadStream

	
	^ aReadStream nextString
	! !

!FLStringClusterSerializer methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/23/2010 08:45'!
serialize: aString on: aWriteStream

	aWriteStream nextPut: (aString).! !

FLPrimitiveClusterSerializer subclass: #FLSymbolClusterSerializer
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLSymbolClusterSerializer class methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/23/2010 17:46'!
instance
	^ Instance ifNil: [ Instance := self basicNew initialize ]! !

!FLSymbolClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/23/2010 11:00'!
id

	^3! !

!FLSymbolClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/23/2010 11:08'!
materializeOn: aReadStream

	| size aByteArray  |
	size := aReadStream nextWord.
	aByteArray := aReadStream next: size.
	^ aByteArray asString asSymbol ! !

!FLSymbolClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/23/2010 10:57'!
serialize: aSymbol on: aWriteStream

	aWriteStream nextWordPut: aSymbol  size.
	aWriteStream nextPutAll: aSymbol asString.! !

Object subclass: #FLMaterializer
	instanceVariableNames: 'stream clusterSerializers referenceMaterializingActions materializedInstances materializedRoots referenceMaterializer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core'!

!FLMaterializer class methodsFor: 'creation' stamp: 'MartinDias 9/20/2010 20:34'!
on: aReadStream

	^self new
		stream: aReadStream; 
		yourself
! !

!FLMaterializer methodsFor: 'private' stamp: 'sd 9/8/2010 15:47'!
clusterSerializerFor: id

	^clusterSerializers at: id.! !

!FLMaterializer methodsFor: 'initialize-release' stamp: 'TristanBourgois 9/25/2010 19:37'!
initialize 
	
	clusterSerializers := IdentityDictionary new.
	self register: FLObjectClusterSerializer instance.
	self register: FLOneByteIntegerClusterSerializer instance.
	self register:  FLSymbolClusterSerializer instance.
	self register: FLNilTrueFalseClusterSerializer instance.
	self register: FLCharacterClusterSerializer instance.
	self register: FLLargePositiveIntegerClusterSerializer instance.
	self register: FLLargeNegativeIntegerClusterSerializer instance.
	self register: FLSmallIntegerClusterSerializer  instance.
	self register: FLSmallIntegerNegativeClusterSerializer  instance.
	referenceMaterializingActions := OrderedCollection new.! !

!FLMaterializer methodsFor: 'materializing' stamp: 'MartinDias 9/22/2010 14:37'!
materialize
	self materializeInstances.
	self materializeReferences.
	self materializeRoots.! !

!FLMaterializer methodsFor: 'private' stamp: 'MartinDias 9/11/2010 19:22'!
materializeCluster
	| clusterSerializerId instanceCount clusterSerializer |
	clusterSerializerId := stream nextWord.
	clusterSerializer := self clusterSerializerFor: clusterSerializerId.
	clusterSerializer materializeOn: stream addTo: materializedInstances mainMaterializer: self! !

!FLMaterializer methodsFor: 'private' stamp: 'MartinDias 9/24/2010 01:51'!
materializeInstances

	| clusterCount objectCount |

	referenceMaterializer := self clusterSerializerFor: stream nextWord.

	objectCount := stream nextWord.
	materializedInstances := OrderedCollection new: objectCount.

	clusterCount := stream nextWord.
	clusterCount timesRepeat: [self materializeCluster].
! !

!FLMaterializer methodsFor: 'private' stamp: 'MartinDias 9/11/2010 19:08'!
materializeReferences

	referenceMaterializingActions
		do: [ :aBlock | aBlock value ]
! !

!FLMaterializer methodsFor: 'private' stamp: 'MartinDias 9/24/2010 09:33'!
materializeRoots

	| rootsSize |
	
	rootsSize := referenceMaterializer materializeOn: stream.
	materializedRoots := Bag new: rootsSize.
	rootsSize timesRepeat: [ materializedRoots add: self nextReferencedObject ]! !

!FLMaterializer methodsFor: 'accessing' stamp: 'MartinDias 9/21/2010 00:32'!
materializedInstances
	^ materializedInstances! !

!FLMaterializer methodsFor: 'accessing' stamp: 'MartinDias 9/22/2010 14:50'!
materializedRoots 

	^ materializedRoots! !

!FLMaterializer methodsFor: 'private' stamp: 'MartinDias 9/24/2010 01:47'!
nextReferencedObject 

	| referenceIndex |
	referenceIndex := referenceMaterializer materializeOn: stream.
	^ materializedInstances at: referenceIndex.! !

!FLMaterializer methodsFor: 'accessing' stamp: 'MartinDias 9/11/2010 19:09'!
referenceMaterializingActions
	^ referenceMaterializingActions! !

!FLMaterializer methodsFor: 'private' stamp: 'sd 9/8/2010 15:55'!
register: aClusterSerializer

	clusterSerializers at: aClusterSerializer id put: aClusterSerializer. ! !

!FLMaterializer methodsFor: 'accessing' stamp: 'sd 9/8/2010 15:23'!
stream: aStream
	stream:= aStream.! !

Object subclass: #FLReferencesAnalyzer
	instanceVariableNames: 'clusteredInstances objectCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core'!

!FLReferencesAnalyzer methodsFor: 'analysis' stamp: 'TristanBourgois 9/23/2010 09:32'!
analyzeAll: aCollection
	aCollection 
		do: [ :anObject | anObject accept: self ]
! !

!FLReferencesAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 9/21/2010 00:05'!
clusteredInstances
	
	^ clusteredInstances! !

!FLReferencesAnalyzer methodsFor: 'visiting' stamp: 'MartinDias 9/24/2010 02:00'!
initialize 

	clusteredInstances:= Dictionary new.
	objectCount := 0.

! !

!FLReferencesAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 9/20/2010 23:57'!
objectCount
	^ objectCount! !

!FLReferencesAnalyzer methodsFor: 'visiting' stamp: 'MartinDias 9/24/2010 02:42'!
visitObject: anObject

	(clusteredInstances 
		at: anObject fuelSerializer   
		ifAbsentPut: [ OrderedCollection new ]) 
			add: anObject.
	objectCount := objectCount + 1.! !

Object subclass: #FLSerializer
	instanceVariableNames: 'stream instanceIndexes referenceSerializingActions referenceSerializer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core'!

!FLSerializer class methodsFor: 'as yet unclassified' stamp: 'sd 9/8/2010 14:59'!
on: aWriteStream

	| serializer |
	serializer := self new.
	serializer stream: aWriteStream.
	^serializer.! !

!FLSerializer methodsFor: 'accessing' stamp: 'MartinDias 9/24/2010 01:44'!
addReferenceTo: anObject

	referenceSerializer serialize: (instanceIndexes at: anObject) on: stream! !

!FLSerializer methodsFor: 'initialize-release' stamp: 'MartinDias 9/23/2010 17:36'!
initialize 
	instanceIndexes := IdentityDictionary new.

	referenceSerializingActions := OrderedCollection new.! !

!FLSerializer methodsFor: 'accessing' stamp: 'MartinDias 9/11/2010 18:53'!
instanceIndexes
	^ instanceIndexes! !

!FLSerializer methodsFor: 'accessing' stamp: 'MartinDias 9/11/2010 18:53'!
instanceIndexes: anObject
	instanceIndexes := anObject! !

!FLSerializer methodsFor: 'accessing' stamp: 'MartinDias 9/11/2010 19:01'!
referenceSerializingActions
	^referenceSerializingActions! !

!FLSerializer methodsFor: 'serializing' stamp: 'MartinDias 9/22/2010 14:36'!
serializeAll: rootsCollection
	
	self serializeInstances: rootsCollection.
	self serializeReferences.
	self serializeRoots: rootsCollection.
! !

!FLSerializer methodsFor: 'private' stamp: 'TristanBourgois 9/24/2010 14:56'!
serializeInstances: rootsCollection

	| counter analyzer clusteredInstances objectCount |
	
	analyzer:= FLReferencesAnalyzer new 
		analyzeAll: rootsCollection;
		yourself.
		
	clusteredInstances := analyzer clusteredInstances.
	objectCount := analyzer objectCount.

	referenceSerializer := objectCount fuelSerializer.
	stream nextWordPut: referenceSerializer id. 
	
	stream nextWordPut: objectCount.
	stream nextWordPut: clusteredInstances keys size.
	counter := 1.
	clusteredInstances
		keysAndValuesDo: [ :serializer :instances | 
			stream nextWordPut: serializer id.
			serializer serializeAll: instances on: stream mainSerializer: self.
			instances
				do: [ :instance | 
					instanceIndexes at: instance put: counter.
					counter := counter + 1 ] ]! !

!FLSerializer methodsFor: 'private' stamp: 'MartinDias 9/11/2010 19:04'!
serializeReferences

	referenceSerializingActions 
		do: [ :aBlock | aBlock value ]! !

!FLSerializer methodsFor: 'serializing' stamp: 'MartinDias 9/24/2010 02:52'!
serializeRoots: rootsCollection

	referenceSerializer serialize: rootsCollection size on: stream.
	
	rootsCollection
		do: [ :instance | self addReferenceTo: instance ]! !

!FLSerializer methodsFor: 'accessing' stamp: 'sd 9/8/2010 14:59'!
stream
	^ stream! !

!FLSerializer methodsFor: 'accessing' stamp: 'sd 9/8/2010 14:59'!
stream: anObject
	stream := anObject! !

!Object methodsFor: '*Fuel-analysis' stamp: 'MartinDias 9/22/2010 16:13'!
accept: aVisitor

	aVisitor visitObject: self.

	self class isVariable 
		ifTrue: [ 
			1 to: self basicSize 
				do: [ :index | (self basicAt: index) accept: aVisitor ] ].
			
	1 to: self class instSize 
		do: [ :index | (self instVarAt: index) accept: aVisitor ]! !

!Object methodsFor: '*Fuel' stamp: 'MartinDias 9/24/2010 01:36'!
fuelSerializer

	^ FLObjectClusterSerializer for: self class! !

Object subclass: #Pair
	instanceVariableNames: 'left right'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Tests'!

!Pair methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/24/2010 02:01'!
= aPair
	(aPair isKindOf: Pair)
		ifTrue: [ ^ self left = aPair left and: [ self right = aPair right ] ].
	^ false! !

!Pair methodsFor: 'accessing' stamp: 'MartinDias 9/16/2010 19:58'!
left
	^ left! !

!Pair methodsFor: 'accessing' stamp: 'MartinDias 9/16/2010 19:58'!
left: anObject
	left := anObject! !

!Pair methodsFor: 'accessing' stamp: 'MartinDias 9/16/2010 19:58'!
right
	^ right! !

!Pair methodsFor: 'accessing' stamp: 'MartinDias 9/16/2010 19:58'!
right: anObject
	right := anObject! !

Object subclass: #Titi
	instanceVariableNames: 'name surname age'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Tests'!

!Titi class methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/23/2010 09:31'!
with: aName with: aSurname with: anAge
	|titi|
	titi:=Titi new.
	titi name:aName.
	titi surname:aSurname.
	titi age:anAge.
	^titi! !

!Titi methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/23/2010 09:00'!
= aTiti

	(aTiti isKindOf: Titi)ifTrue:[
		^ ((aTiti age=self age) and:[aTiti name1=self name1])and:[aTiti surname=self surname].
		].
		^false! !

!Titi methodsFor: 'accessing' stamp: 'TristanBourgois 9/23/2010 08:59'!
age
	^ age! !

!Titi methodsFor: 'accessing' stamp: 'TristanBourgois 9/23/2010 08:59'!
age: anObject
	age := anObject! !

!Titi methodsFor: 'accessing' stamp: 'TristanBourgois 9/23/2010 08:59'!
name1
	^ name! !

!Titi methodsFor: 'accessing' stamp: 'TristanBourgois 9/23/2010 08:59'!
name: anObject
	name := anObject! !

!Titi methodsFor: 'accessing' stamp: 'TristanBourgois 9/23/2010 09:00'!
surname
	^ surname! !

!Titi methodsFor: 'accessing' stamp: 'TristanBourgois 9/23/2010 09:00'!
surname: anObject
	surname := anObject! !

!Titi methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/23/2010 09:06'!
with: aName with: aSurname with: anAge

	name:=aName.
	surname:=aSurname.
	age:=anAge.! !
